<?php
/**
 * Plugin Name: Dadevarzan WordPress subcompany plugin
 * Plugin URI: https://wordpress.org/plugins/dadevarzan-wp-subcompany
 * GitHub Plugin URI: https://github.com/dadevarzan/dadevarzan-wp-subcompany
 * Description: subcompany post type for wordpress
 * Version: 1.1.6
 * Author: Dadevarzan Team
 * Author URI: http://www.dadevarzan.com
 * Text Domain: dadevarzan-wp-subcompany
 * Domain Path: /languages
*/

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die;
}

if ( !class_exists( 'dadevarzanWpSubcompany' ) ) {

    class dadevarzanWpSubcompany
    {

        public static function initialize()
        {
            add_action( 'plugins_loaded', 'dadevarzanWpSubcompany::load_text_domain' );
            add_action( 'init', 'dadevarzanWpSubcompany::add_post_type' );
            add_action( 'init', 'dadevarzanWpSubcompany::add_fields' );
            add_action('init', 'dadevarzanWpSubcompany::add_role_caps');
            add_action( 'plugins_loaded', 'dadevarzanWpSubcompany::load_templates' );

        }

        public static function add_post_type()
        {

            $labels = array(
                "name" => __('Subcompanies', 'dadevarzan-wp-subcompany'),
                "singular_name" => __('Subcompany', 'dadevarzan-wp-subcompany'),
                "all_items" => __('All Subcompanies', 'dadevarzan-wp-subcompany'),
                "add_new" => __('Add Subcompany', 'dadevarzan-wp-subcompany'),
                "add_new_item" => __('Add New Subcompany', 'dadevarzan-wp-subcompany'),
                "edit_item" => __('Edit Subcompany', 'dadevarzan-wp-subcompany'),
                "new_item" => __('New Subcompany', 'dadevarzan-wp-subcompany'),
                "view_item" => __('View Subcompany', 'dadevarzan-wp-subcompany'),
            );

            $args = array(
                "label" => __('Subcompanies', 'dadevarzan-wp-subcompany'),
                "labels" => $labels,
                "description" => "",
                "public" => true,
                "publicly_queryable" => true,
                "show_ui" => true,
                "show_in_rest" => true,
                "rest_base" => "",
				"show_in_nav_menus" => true,
                "has_archive" => true,
                "show_in_menu" => true,
                "exclude_from_search" => false,
                "hierarchical" => false,
                "rewrite" => array( "slug" => "subcompany", "with_front" => true ),
                "query_var" => true,
                "menu_icon" => "dashicons-admin-multisite",
                "supports" => array( "title", "excerpt", "editor", "thumbnail", "comments", "author" ),
                "capability_type" => array('subcompany', 'subcompanies'),
                "map_meta_cap" => true,
            );

            register_post_type( "subcompany", $args );

        }

        public static function add_fields()
        {

            if( function_exists('acf_add_local_field_group') ):

                acf_add_local_field_group(array(
                    'key' => 'group_5a02ac8256ef2',
                    'title' => __('Subcompanies', 'dadevarzan-wp-subcompany'),
                    'fields' => array(
                        array(
                            'key' => 'field_5a02aca8e1c34',
                            'label' => __('Header image', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_header_image',
                            'type' => 'image',
                            'instructions' => '',
                            'required' => 1,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'return_format' => 'array',
                            'preview_size' => 'thumbnail',
                            'library' => 'all',
                            'min_width' => 500,
                            'min_height' => 200,
                            'min_size' => '',
                            'max_width' => 2000,
                            'max_height' => 1000,
                            'max_size' => '',
                            'mime_types' => 'jpeg,jpg,png,gif',
                        ),
                        array(
                            'key' => 'field_5a02af78e1c35',
                            'label' => __('Other image', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_other_pictures',
                            'type' => 'gallery',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'min' => '',
                            'max' => '',
                            'insert' => 'append',
                            'library' => 'all',
                            'min_width' => '',
                            'min_height' => '',
                            'min_size' => '',
                            'max_width' => '',
                            'max_height' => '',
                            'max_size' => '',
                            'mime_types' => 'jpeg,jpg,gif,png',
                        ),
                        array(
                            'key' => 'field_5a02cd72522e3',
                            'label' => __('Activity fields', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_activity',
                            'type' => 'text',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                            'prepend' => '',
                            'append' => '',
                            'maxlength' => '',
                        ),
                        array(
                            'key' => 'field_5a02cdc1522e4',
                            'label' => __('Address', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_address',
                            'type' => 'text',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                            'prepend' => '',
                            'append' => '',
                            'maxlength' => '',
                        ),
                        array(
                            'key' => 'field_5a02cdd9522e5',
                            'label' => __('Phone', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_tel',
                            'type' => 'text',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                            'prepend' => '',
                            'append' => '',
                            'maxlength' => '',
                        ),
                        array(
                            'key' => 'field_5a02cdf5522e6',
                            'label' => __('Fax', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_fax',
                            'type' => 'text',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                            'prepend' => '',
                            'append' => '',
                            'maxlength' => '',
                        ),
                        array(
                            'key' => 'field_5a02ce04522e7',
                            'label' => __('Email', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_email',
                            'type' => 'email',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                            'prepend' => '',
                            'append' => '',
                        ),
                        array(
                            'key' => 'field_5a02de9f522e8',
                            'label' => __('Website URL', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_website',
                            'type' => 'url',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'default_value' => '',
                            'placeholder' => '',
                        ),
                        array(
                            'key' => 'field_5a02e4b997a0f',
                            'label' => __('Map position', 'dadevarzan-wp-subcompany'),
                            'name' => 'sub_map',
                            'type' => 'google_map',
                            'instructions' => '',
                            'required' => 0,
                            'conditional_logic' => 0,
                            'wrapper' => array(
                                'width' => '',
                                'class' => '',
                                'id' => '',
                            ),
                            'center_lat' => '35.757541',
                            'center_lng' => '51.409955',
                            'zoom' => 15,
                            'height' => '',
                        ),
                    ),
                    'location' => array(
                        array(
                            array(
                                'param' => 'post_type',
                                'operator' => '==',
                                'value' => 'subcompany',
                            ),
                        ),
                    ),
                    'menu_order' => 0,
                    'position' => 'acf_after_title',
                    'style' => 'default',
                    'label_placement' => 'top',
                    'instruction_placement' => 'label',
                    'hide_on_screen' => '',
                    'active' => 1,
                    'description' => '',
                ));

            endif;

        }

        public static function add_role_caps()
        {

            // Add the roles you'd like to administer the custom post types
            $roles = array('wpseo_editor', 'wpseo_manager', 'shop_manager', 'editor', 'administrator');

            // Loop through each role and assign capabilities
            foreach($roles as $the_role) {

                $role = get_role($the_role);

                if ( empty($role) ) {
                    continue;
                }

                $role->add_cap( 'read' );
                $role->add_cap( 'read_subcompany' );
                $role->add_cap( 'edit_subcompany' );
                $role->add_cap( 'edit_subcompanies' );
                $role->add_cap( 'edit_private_subcompanies' );
                $role->add_cap( 'edit_published_subcompanies' );
                $role->add_cap( 'edit_others_subcompanies' );
                $role->add_cap( 'delete_subcompany' );
                $role->add_cap( 'delete_subcompanies' );
                $role->add_cap( 'delete_private_subcompanies' );
                $role->add_cap( 'delete_published_subcompanies' );
                $role->add_cap( 'delete_others_subcompanies' );
                $role->add_cap( 'publish_subcompanies' );
                $role->add_cap( 'read_private_subcompanies' );

            }

        }

        public static function load_templates() {

            /**
             * Return if the builder isn't installed or if the current
             * version doesn't support registering templates.
             */
            if ( ! class_exists( 'FLBuilder' ) || ! method_exists( 'FLBuilder', 'register_templates' ) ) {
                return;
            }

            $layoutTemplatePath = plugin_dir_path( __FILE__ ) . 'data/templates.dat';
            if ( file_exists( $layoutTemplatePath ) && class_exists( 'FLThemeBuilder' ) ) {
                FLBuilder::register_templates( $layoutTemplatePath, array('group' => 'subcompany'));
            }

        }

        public static function load_text_domain()
        {
            load_plugin_textdomain( 'dadevarzan-wp-subcompany' , FALSE, basename( dirname( __FILE__ ) ) . '/languages'  );
        }

    }

    dadevarzanWpSubcompany::initialize();

}
